<template>
    <div class="mt-4">

        <div>
            <b-modal ref="putmodal" hide-footer id="modal-1" title="BootstrapVue">
                <div class="form-group">
                    <form method="put" @submit.prevent="putTrainer(trainerUpdate.id)">
                        <input type="text" name="name" id="" placeholder="Name" v-model="trainerUpdate.name"
                            class="form-control"> <br>
                        <input type="text" name="email" id="" placeholder="E-Mail" v-model="trainerUpdate.eMailAdresse"
                            class="form-control"> <br>
                        <input type="text" name="adresse" id="" placeholder="Adresse" v-model="trainerUpdate.adresse"
                            class="form-control"> <br>
                        <input type="text" name="telnummer" id="" placeholder="Tel-Nummer"
                            v-model="trainerUpdate.telNummer" class="form-control"> <br>
                        <input type="text" name="startdatum" id="" placeholder="Anstellung"
                            v-model="trainerUpdate.anstellung" class="form-control"> <br>
                        <input type="text" name="enddatum" id="" placeholder="Bruttogehalt"
                            v-model="trainerUpdate.bruttoGehalt" class="form-control"> <br>
                        <input type="text" name="enddatum" id="" placeholder="FachWissen"
                            v-model="trainerUpdate.fachEnums" class="form-control"> <br>
                        <label for="">Fach wählen</label>
                        <select class="form-control form-select-lg mb-3" name="TrainerAnstellung" id=""
                            v-model="trainerUpdate.fachId">
                            <option v-for="fach in alleFaecher" :key='fach.id' :value="fach.id">{{ fach.fachUnterricht }},
                                {{ fach.fachBezeichnung }}</option>
                        </select>
                        <button type="submit" class="btn container-fluid btn-info">Speichern</button>
                    </form>
                </div>

            </b-modal>
        </div>

        <table class="table">
            <th>Name</th>
            <th>e-mailAdresse</th>
            <th>Tel-Nummer</th>
            <th>Adresse</th>
            <th>Anstellung</th>
            <th>Fach</th>
            <th>Bruttogehalt</th>
            <th>Nettogehalt</th>
            <th></th>
            <tr v-for="(trainer, id) in alleTrainer" :key='id'>
                <td>{{ trainer.name }}</td>
                <td>{{ trainer.eMailAdresse }}</td>
                <td>{{ trainer.telNummer }}</td>
                <td>{{ trainer.adresse }}</td>
                <td>{{ trainer.anstellung }}</td>
                <td>{{ trainer.fachEnums }}</td>
                <td>{{ trainer.bruttoGehalt }}</td>
                <td>{{ trainer.nettoGehalt }}</td>
                <button type="button" class="btn btn-danger m-1" @click="deleteTrainer(trainer.id)">X</button>
                <button type="button" class="btn btn-primary m-1" v-b-modal.modal-1
                    @click="editTrainer(trainer)">O</button>
            </tr>
        </table>
    </div>
</template>

<script>
export default {
    name: 'TrainerListTable',
    components: {

    },
    data() {
        return {

            trainerUpdate: {
                name: '',
                eMailAdresse: '',
                telNummer: '',
                adresse: '',
                anstellung: '',
                bruttoGehalt: '',
                fachEnums: '',
                fachId: '',
                id: ''
            }
        };
    },

    computed: {
        alleTrainer() {
            return this.$store.state.alleTrainer;
        },

        trainerByIdNetto() {
            return this.$store.state.trainerByIdNetto;
        },

        alleFaecher() {
            return this.$store.state.alleFaecher
        },
    },

    mounted() {
        //this.getAllTeilnehmer()
        this.$store.dispatch("getAlleTrainer");
        this.$store.dispatch("getAlleFaecher");
    },

    methods: {

        async deleteTrainer(id) {
            const deleteTrainer = this.$store.dispatch("deleteTrainer", id)
            console.log(deleteTrainer)
        },

        async putTrainer(trainerUpdate) {
            console.log(trainerUpdate)
            console.warn(trainerUpdate.id)
            this.$store.dispatch("putTrainer", this.trainerUpdate)//muss this.trainer sein wegen id
            this.hideModal();
        },

        async editTrainer(trainerUpdate) {
            this.trainerUpdate.name = trainerUpdate.name;
            this.trainerUpdate.eMailAdresse = trainerUpdate.eMailAdresse;
            this.trainerUpdate.telNummer = trainerUpdate.telNummer;
            this.trainerUpdate.adresse = trainerUpdate.adresse;
            this.trainerUpdate.anstellung = trainerUpdate.anstellung;
            this.trainerUpdate.bruttoGehalt = trainerUpdate.bruttoGehalt;
            this.trainerUpdate.fachEnums = trainerUpdate.fachEnums;
            this.trainerUpdate.fachId = trainerUpdate.fachId;
            this.trainerUpdate.id = trainerUpdate.id;
        },

        hideModal() {
            this.$refs['putmodal'].hide();
        }


    }

}
</script>